//
//  DetailViewController.m
//  TableDesignRevisited
//
//  Created by Paul Wong on 9/15/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.

#import "DetailViewController.h"
#import "NibLoadedCell.h"

@implementation DetailViewController

//
// initWithRowIndex:
//
// Initializes the detail view with the only "detail view" piece of information:
// the row index of the selected view.
//
// Parameters:
//    aRowIndex - the selected row index
//
// returns the initialized row
//
- (id)initWithRowIndex:(NSInteger)aRowIndex
{
	self = [super init];
	if (self != nil)
	{
		rowIndex = aRowIndex;
	}
	return self;
}

//
// title
//
// returns the navigation item title
//
- (NSString *)title
{
	return NSLocalizedString(@"Detail View", @"");
}

//
// nibName
//
// returns the name of the NIB file from which this view is loaded
//
- (NSString *)nibName
{
	return @"DetailView";
}

//
// viewDidLoad
//
// Constructs a single, static row.
//
- (void)viewDidLoad
{
    [super viewDidLoad];
	
	[self addSectionAtIndex:0 withAnimation:UITableViewRowAnimationNone];
	[self
		appendRowToSection:0
		cellClass:[NibLoadedCell class]
		cellData:[NSString stringWithFormat:
			NSLocalizedString(@"You selected NIB loaded cell %ld", @""), rowIndex + 1]
		withAnimation:UITableViewRowAnimationNone];
}

@end
